//
// Copyright 2016 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
#ifndef PXR_USDINSHIPPED_DECLARECOREOPS_H
#define PXR_USDINSHIPPED_DECLARECOREOPS_H

#include "usdKatana/usdInPluginRegistry.h"

PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_XformOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_ScopeOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_MeshOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_GeomSubsetOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_NurbsPatchOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_PointInstancerOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_PointsOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_BasisCurvesOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE_WITH_FLUSH(PxrUsdInCore_LookOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_LightOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_LightFilterOp)

PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_ModelOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_CameraOp)

PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_ConstraintsOp)
PXRUSDKATANA_USDIN_PLUGIN_DECLARE(PxrUsdInCore_LooksGroupOp)

#endif // PXR_USDINSHIPPED_DECLARECOREOPS_H
